//---------------------------------------------------------------------------
#ifndef KeyringWinsH
#define KeyringWinsH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\ExtCtrls.hpp>
#include "explbtn.hpp"
#include <vcl\ComCtrls.hpp>
#include <vcl\Menus.hpp>
#include "global.h"
//---------------------------------------------------------------------------
class TCustomKey : public TStringList
{
public:
   __property AnsiString name        = { read=Name };
   __property AnsiString keyid       = { read=KeyId };
   __property AnsiString address     = { read=Address };
   __property AnsiString description = { read=Description };
   __property bool enabled           = { read=fEnabled, write=SetEnabled };
   virtual __fastcall TCustomKey();
   virtual __fastcall TCustomKey(TCustomKey *key);
   virtual __fastcall TCustomKey(TStrings *key, bool Enabled=true);
   virtual __fastcall~TCustomKey();
protected:
   virtual void __fastcall SetEnabled(bool enabled);
   virtual AnsiString __fastcall Description();
   virtual AnsiString __fastcall Address();
   virtual AnsiString __fastcall KeyId();
   virtual AnsiString __fastcall Name();
   bool fEnabled;
};

class TCustomKeyList : public TStringList
{
public:
   int shrtLen;
   int addrLen;
   bool modified;
   virtual __fastcall TCustomKeyList();
   virtual __fastcall TCustomKeyList(AnsiString filename);
   virtual __fastcall TCustomKeyList(TCustomKeyList *keys);
   virtual __fastcall TCustomKeyList(TCustomKey *key);
   virtual __fastcall TCustomKeyList(TStrings *keys);
   virtual __fastcall~TCustomKeyList();
   virtual bool __fastcall FindKey(TCustomKey *key, int &pos);
   virtual void __fastcall SaveToFileBak(AnsiString &filename, int bakcopies);
   virtual AnsiString __fastcall KeyDescription(int atPos);
   virtual void __fastcall LoadFromFile(AnsiString filename);
   virtual void __fastcall LoadFromStrings(TStrings *keys);
   virtual int  __fastcall AddKeys(TCustomKeyList *keys);
   virtual int  __fastcall AddKeys(TStrings *keys);
   virtual bool __fastcall AddKey(TCustomKey *key);
   virtual bool __fastcall AddKey(TStrings *key);
   virtual void __fastcall EnableKey(int atPos, bool enable);
   virtual void __fastcall DeleteKey(int atPos);
   virtual TCustomKey*__fastcall Key(int atPos);
   virtual void __fastcall Clear();
};

class TCustomKeyWin : public TForm
{
__published:	// IDE-managed Components
	TTreeView *TreeView;
	TTimer *Timer1;
	TTimer *FlashTimer;
	TOfficeButton *DeleteBtn;
	TOfficeButton *HelpBtn;
	TOfficeButton *OkBtn;
	TOfficeButton *ImportBtn;
	TOfficeButton *SaveBtn;
	TOfficeButton *DocsBtn;
	TOfficeButton *RefreshBtn;
	TOfficeButton *DisableBtn;
	TOfficeButton *RequestBtn;
	TOfficeButton *ClearAllBtn;
	TOfficeButton *HideDisBtn;
	TPopupMenu *PopupMenu;
	TPopupMenu *PopupMenu2;
	TMenuItem *PopDisableItem;
	TMenuItem *N1;
	TMenuItem *Clear1;
	TMenuItem *PopSaveItem;
	TMenuItem *PopRefreshItem;
	TMenuItem *PopImportItem;
	TMenuItem *N3;
	TMenuItem *PopExpandItem;
	TMenuItem *PopCollapseItem;
	TMenuItem *PopDeleteItem;
	TMenuItem *N4;
	TPanel *Panel1;
	TBevel *Bevel5;
	TBevel *Bevel3;
	TBevel *Bevel2;
	TBevel *Bevel1;
	void __fastcall Timer1Timer(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall HideDisBtnClick(TObject *Sender);
	void __fastcall ClearAllBtnClick(TObject *Sender);
	void __fastcall TreeViewMouseDown(TObject *Sender, TMouseButton Button,
   	   TShiftState Shift, int X, int Y);
	void __fastcall DisableBtnClick(TObject *Sender);
	void __fastcall TreeViewChange(TObject *Sender, TTreeNode *Node);
	void __fastcall OkBtnClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall PopExpandItemClick(TObject *Sender);
	void __fastcall PopCollapseItemClick(TObject *Sender);
	void __fastcall SaveBtnClick(TObject *Sender);
	void __fastcall RefreshBtnClick(TObject *Sender);
	void __fastcall DeleteBtnClick(TObject *Sender);
	void __fastcall RemailerDocItemClick(TObject *Sender);
	void __fastcall FormActivate(TObject *Sender);
	void __fastcall ImportBtnClick(TObject *Sender);
	void __fastcall HelpBtnClick(TObject *Sender);
	void __fastcall RequestBtnClick(TObject *Sender);
	void __fastcall FormDeactivate(TObject *Sender);
private:	// User declarations
public:		// User declarations
    int curkey;
    TList *keynodes;
    TCustomKeyList *keys;
    AnsiString cap,keyringname;
    TStringList *newkeys,*diskeys;
    bool checksave,initdone,hidedisabled;
    Graphics::TBitmap *bmpHideDis,*bmpShowAll,*bmpOrg;
	__fastcall TCustomKeyWin(TComponent* Owner);
 	virtual __fastcall ~TCustomKeyWin();
    TTreeNode* __fastcall Node(int atPos);
    virtual TCustomKey* __fastcall NodeKey(int atPos);
    void __fastcall SetTreeItemBold(TTreeNode *ANode, bool Value, TTreeView *ATree);
    void __fastcall EnableDisableBtn(bool enable);
    void __fastcall SetNothingSelected();
    void __fastcall SetCount(bool clear=false);
    virtual void __fastcall EnableKey(int atPos, bool enable);
    virtual void __fastcall AddKeysImport(TCustomKeyList *newkeys);
    virtual void __fastcall LoadTreeViewQuiet();
    virtual void __fastcall LoadTreeView();
    virtual void __fastcall LoadKeys();
    virtual void __fastcall SaveKeys();
    void __fastcall DeleteKey(int atPos);
    void __fastcall SetHelpBtnPos();
    void __fastcall ClearTree();
    void __fastcall GetKeyringMenuDat(KeyringMenuDat *menudat);
    // message functions
    void __fastcall WMSaveBtnClicked(TMessage& Msg);
    void __fastcall WMRefreshBtnClicked(TMessage& Msg);
    void __fastcall WMImportBtnClicked(TMessage& Msg);
    void __fastcall WMDisableBtnClicked(TMessage& Msg);
    void __fastcall WMDeleteBtnClicked(TMessage& Msg);
     // message map
    BEGIN_MESSAGE_MAP
    MESSAGE_HANDLER(WM_SAVEBTNCLICKED,TMessage,WMSaveBtnClicked)
    MESSAGE_HANDLER(WM_REFRESHBTNCLICKED,TMessage,WMRefreshBtnClicked)
    MESSAGE_HANDLER(WM_IMPORTBTNCLICKED,TMessage,WMImportBtnClicked)
    MESSAGE_HANDLER(WM_DISABLEBTNCLICKED,TMessage,WMDisableBtnClicked)
    MESSAGE_HANDLER(WM_DELETEBTNCLICKED,TMessage,WMDeleteBtnClicked)
    END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern TCustomKeyWin *CustomKeyWin;
//---------------------------------------------------------------------------
#endif
