//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#pragma hdrstop

#include "MixKeyWins1.h"
#include "MixKeyClrDlgs.h"
#include "MixKeyDelDlgs.h"
#include "MixKeyImpDlgs.h"
#include "Mixmaster.h"
#include "HelpDlgs.h"
#include "ClipReply.h"
#include "FileWin.h"
#include "msgwins.h"
#include "fileman.h"
#include "wipedlgs.h"
#include "view.h"
//---------------------------------------------------------------------------
#pragma link "explbtn"
#pragma resource "*.dfm"
TMixKeyWin1 *MixKeyWin1;
#define ENABLE true
const AnsiString MRINGTXT = mringtxt;
//---------------------------------------------------------------------------
// TMixKey
//---------------------------------------------------------------------------
__fastcall TMixKey::TMixKey()
   : TStringList()
{
   enabled = true;
}
//---------------------------------------------------------------------------
__fastcall TMixKey::TMixKey(TMixKey *key)
   : TStringList()
{
   enabled = key->enabled;
   Text = key->Text;
}
//---------------------------------------------------------------------------
__fastcall TMixKey::TMixKey(TStrings *key, bool Enabled)
   : TStringList()
{
   enabled = Enabled;
   Text = key->Text;
}
//---------------------------------------------------------------------------
__fastcall TMixKey::~TMixKey()
{
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey::ShortName()
{
   if (Count>0) return GetToken(0,Strings[0]," ");
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey::EAddress()
{
   if (Count>0) return GetToken(1,Strings[0]," ");
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey::KeyId()
{
   if (Count>0) return GetToken(2,Strings[0]," ");
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey::Version()
{
   if (Count>0) return GetToken(3,Strings[0]," ");
   return "";
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKey::Caps()
{
   if (Count>0) return GetToken(4,Strings[0]," ");
   return "";
}
//---------------------------------------------------------------------------
// TMixKeyList
//---------------------------------------------------------------------------
__fastcall TMixKeyList1::TMixKeyList1()
   : TStringList()
{
   type2 = new TStringList();
   GetType2(type2);
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList1::TMixKeyList1(AnsiString filename)
   : TStringList()
{
   type2 = new TStringList();
   GetType2(type2);
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
   versLen = 0;
   LoadFromFile(filename);
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList1::TMixKeyList1(TMixKeyList1 *keys)
   : TStringList()
{
   type2 = new TStringList();
   GetType2(type2);
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
   versLen = 0;
   AddKeys(keys);
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList1::TMixKeyList1(TStrings *keys)
   : TStringList()
{
   type2 = new TStringList();
   GetType2(type2);
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
   versLen = 0;
   AddKeys(keys);
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList1::TMixKeyList1(TMixKey *key)
   : TStringList()
{
   type2 = new TStringList();
   GetType2(type2);
   Sorted = true;
   shrtLen = 0;
   addrLen = 0;
   versLen = 0;
   AddKey(key);
}
//---------------------------------------------------------------------------
__fastcall TMixKeyList1::~TMixKeyList1()
{
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList1::GetType2(TStrings *Type2)
{
   if (FileExists(mtyp2txt)) Type2->LoadFromFile(mtyp2txt);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList1::SaveToFileBak(AnsiString &docname, int bakcopies)
{
   TMixKey *key;
   AnsiString desc;
   TStringList *keys = new TStringList();
   type2->Clear();

   for (int i=0; i<Count; i++)
   {
      key = MixKey(i);
      if (!key || key->Count<15) continue;
      keys->Add(key->Text);
      type2->Add((key->enabled?"":"#")+
         PadRight(key->name,10)+" "+key->address+" "+key->keyid+" "+
         key->version+" "+key->caps);
   }
   for (int i=bakcopies; i>=1; i--)
   {
      if (FileExists(bak(docname,i))) DeleteFile(bak(docname,i).c_str());
      if (FileExists(bak(docname,i-1)))
          rename(bak(docname,i-1).c_str(),bak(docname,i).c_str());
   }
   if (bakcopies && FileExists(docname))
      rename(docname.c_str(),bak(docname,1).c_str());

   type2->SaveToFile(mtyp2txt);
 ::SaveToFileBak(type2,mtyp2txt,bakcopies);
   keys->SaveToFile(docname);
   delete keys;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyList1::LoadFromFile(AnsiString filename)
{
   Clear();
   TStringList *keys = new TStringList();
   if (FileExists(filename)) keys->LoadFromFile(filename);
   AddKeys(keys);
   delete keys;
}
//---------------------------------------------------------------------------
TMixKey* __fastcall TMixKeyList1::MixKey(int atPos)
{
   if (atPos<0 || atPos>=Count) return NULL;
   return (TMixKey*)Objects[atPos];
}
//---------------------------------------------------------------------------
int __fastcall TMixKeyList1::AddKeys(TMixKeyList1 *keys)
{
   int c=0;
   for (int i=0; i<keys->Count; i++)
   {
      AddKey(keys->MixKey(i));
      c++;
   }
   return c;
}
//---------------------------------------------------------------------------
int __fastcall TMixKeyList1::AddKeys(TStrings *keys)
{
   int c=0;
   AnsiString keydesc,desc;
   TStringList *key=new TStringList();
   TStringList *KEYS=new TStringList();
   KEYS->AddStrings(keys);
   while (MixGetNextKey(keydesc,key,KEYS))
   {
      AddKey(key);
      c++;
   }
   delete KEYS;
   delete key;
   return c;
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyList1::AddKey(TStrings *key)
{
   if (!MixKeyDefinately(key)) return false;
   TMixKey *KEY = new TMixKey(key);
   AddKey(KEY);
   delete KEY;
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyList1::DeleteKey(int atPos)
{
   if (atPos<0 || atPos>=Count) return false;
   delete Objects[atPos];
   Delete(atPos);
   return true;
}
//---------------------------------------------------------------------------
bool __fastcall TMixKeyList1::AddKey(TMixKey *key)
{
   if (!MixKeyDefinately(key)) return false;

   TMixKey *KEY = new TMixKey(key);

   AnsiString line = KEY->Strings[0];
   int pos = line.Pos(" ");
   line.Insert(s("           ").SubString(1,11-pos),pos);
   KEY->enabled = type2->IndexOf("#"+line)<0;

   AnsiString shrt=KEY->name,addr=KEY->address,vers=KEY->version;
   AddObject(shrt+","+addr+","+KEY->keyid+","+vers+","+KEY->caps,KEY);
   if (shrt.Length()>shrtLen) shrtLen = shrt.Length();
   if (addr.Length()>addrLen) addrLen = addr.Length();
   if (vers.Length()>versLen) versLen = vers.Length();
   return true;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList1::KeyDescription(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   addrLen = 31;
   AnsiString desc,addr;
   TStringList *flds = new TStringList();
   flds->CommaText = Strings[atPos];

   addr = PadRight(flds->Strings[1],addrLen);
   if (addr[addrLen]!=' ') addr = addr.SubString(1,addrLen-3)+"...";

   desc = PadRight(flds->Strings[0],shrtLen)+"  "+addr+"  "+flds->Strings[2]+"  "+
      PadRight(flds->Strings[3],versLen)+"  "+flds->Strings[4];
   delete flds;
   return desc;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList1::ShortName(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   AnsiString shrt = GetParam(0,Strings[atPos],",");
   return shrt;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList1::EAddress(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   return GetParam(1,Strings[atPos],",");
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList1::Version(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   return GetParam(2,Strings[atPos],",");
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList1::KeyId(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   return GetParam(3,Strings[atPos],",");
}
//---------------------------------------------------------------------------
AnsiString __fastcall TMixKeyList1::Caps(int atPos)
{
   if (atPos<0 || atPos>=Count) return "";
   return GetParam(4,Strings[atPos],",");
}
//---------------------------------------------------------------------------
// TMixKeyWin
//---------------------------------------------------------------------------
__fastcall TMixKeyWin1::TMixKeyWin1(TComponent* Owner)
	: TForm(Owner)
{
   initdone = false;
   keys = new TMixKeyList1();
   newkeys = new TStringList();
   diskeys = new TStringList();
   keynodes = new TList();
   checksave = true;
   curkey = -1;
   SetHelpBtnPos();
   SetNothingSelected(); SaveBtn->Enabled = RefreshBtn->Enabled = false;
   cap = Caption; Caption = "Loading...";
   hidedisabled = GetAppIni("MixHideDisabled","0")=="1";
   bmpHideDis = new Graphics::TBitmap(); ImageList2->GetBitmap(0,bmpHideDis);
   bmpShowAll = new Graphics::TBitmap(); ImageList2->GetBitmap(1,bmpShowAll);
   HideDisBtn->Bitmap->Assign(hidedisabled?bmpHideDis:bmpShowAll);
   Timer1->Enabled = true;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::Timer1Timer(TObject *Sender)
{
   Timer1->Enabled = false;
   LoadKeys(); GenTreeView();
   initdone = true;
   Caption = cap;
}
//---------------------------------------------------------------------------
__fastcall TMixKeyWin1::~TMixKeyWin1()
{
   MixKeyWin1 = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::LoadKeys()
{
   keys->Clear();
   if (FileExists(MRINGTXT)) keys->LoadFromFile(MRINGTXT);
   modified = false;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::SetHelpBtnPos()
{
   HelpBtn->Left = Width-58;
   HideDisBtn->Left = HelpBtn->Left-(HideDisBtn->Width+1);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::SetNothingSelected()
{
   RequestBtn->Enabled = false;
   EnableDisableBtn(false);
   DeleteBtn->Enabled = false;
   curkey = -1;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::SetCount(bool clear)
{
   AnsiString cur,count;
   if (Application->Terminated) return;
   if (!clear && WindowState!=wsMinimized && keys->Count)
   {
      cur = curkey>=0 ? s(curkey+1)+"/" : s("");
      count = cur+s(keys->Count);
   }
   AppMainForm->Perform(WM_SHOWSTATUS,1,(LPARAM)count.c_str());
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::SetTreeItemBold(TTreeNode *ANode, bool Value,
   TTreeView *ATree)
{
   TTVItem item;
   int Template;
   if (!ANode) return;

   Template = Value ? -1 : 0;
   item.mask = TVIF_STATE;
   item.hItem = (HTREEITEM)ANode->ItemId;
   item.stateMask = TVIS_BOLD;
   item.state = item.stateMask & Template;
   TreeView_SetItem(ATree->Handle,&(TV_ITEM)item);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::GenTreeView()
{
   keynodes->Clear();
   SetRedraw(TreeView,0);
   TTreeNode *node,*cnode;
   TreeView->Items->Clear();

   TStringList *next=new TStringList();
   TreeView->Items->BeginUpdate();
   for (int i=0; i<keys->Count; i++)
   {
      TMixKey *KEY = keys->MixKey(i);
      if (hidedisabled && !KEY->enabled) continue;

      AnsiString keydesc = keys->KeyDescription(i);
      node = TreeView->Items->AddChildObject(TreeView->Selected,keydesc,KEY);

      node->ImageIndex = KEY->enabled ? 0:1;
      node->SelectedIndex = node->ImageIndex;

      if (newkeys->IndexOf(node->Text)>=0) SetTreeItemBold(node,true,TreeView);
      keynodes->Add(node);

      keydesc = KEY->Strings[0];
      cnode=TreeView->Items->AddChild(node,"Name    : "+GetParam(0,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Address : "+GetParam(1,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Key-Id  : "+GetParam(2,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Version : "+GetParam(3,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
      cnode=TreeView->Items->AddChild(node,"Caps    : "+GetParam(4,keydesc," "));
      cnode->ImageIndex = -1; cnode->SelectedIndex = -1;
   }
   TreeView->Items->EndUpdate();
   RECT r = { 0,0,4096,4096 };
   InvalidateRect(TreeView->Handle,&r,false);
   SetRedraw(TreeView,1);
   delete next;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::EnableDisableBtn(bool enable)
{
   Graphics::TBitmap *bitmap=DisableBtn->Bitmap;
   TCanvas *canvas=bitmap->Canvas;
   SetRedraw(DisableBtn,0);
   if (enable)
   {
      for (int h=0; h<bitmap->Height; h++)
         for (int w=0; w<bitmap->Width; w++)
            if (canvas->Pixels[w][h]==clBlack) canvas->Pixels[w][h] = clBlue;
   }
   else
   {
      for (int h=0; h<bitmap->Height; h++)
         for (int w=0; w<bitmap->Width; w++)
            if (canvas->Pixels[w][h]==clBlue) canvas->Pixels[w][h] = clBlack;
   }
   DisableBtn->Enabled = enable;
   SetRedraw(DisableBtn,1);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::FormClose(TObject *Sender, TCloseAction &Action)
{
   Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::FormResize(TObject *Sender)
{
   SetHelpBtnPos();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::HideDisBtnClick(TObject *Sender)
{
   Caption = "Working...";
   hidedisabled = !hidedisabled;
   bool locked = LockWindowUpdate(Handle);
   GenTreeView(); AppProcessMessages();
   HideDisBtn->Bitmap->Assign(hidedisabled?bmpHideDis:bmpShowAll);
   PutAppIni("MixHideDisabled",(hidedisabled?"1":"0"));
   if (locked) LockWindowUpdate(0);
   Caption = cap;
}
//---------------------------------------------------------------------------
TMixKey* __fastcall TMixKeyWin1::NodeKey(int atPos)
{
   if (atPos<0 || atPos>=keynodes->Count) return NULL;
   TMixKey *key = (TMixKey*)((TTreeNode*)keynodes->Items[atPos])->Data;
   return key;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::MakeMessage(TStrings *message, AnsiString &addrs,
   AnsiString &subject)
{
   TStringList *msg = new TStringList(); msg->Text = message->Text;
   for (int i=0; i<msg->Count; i++)
   {
      AnsiString tmpstr = msg->Strings[i];
      if (tmpstr.Pos("To:")==1) msg->Strings[i] = "To: "+addrs;
      if (tmpstr.Pos("Subject:")==1) msg->Strings[i] = "Subject: "+subject;
      if (tmpstr.IsEmpty()) break;
   }
   PutMessageOnDesktop(AppMainForm,msg);
   delete msg;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::EnableKey(int atPos, bool enable)
{
   if (atPos<0 || atPos>=keynodes->Count) return;

   TTreeNode* node = (TTreeNode*)keynodes->Items[atPos];
   TMixKey *key = (TMixKey*)node->Data;
   key->enabled = enable;
   if (enable)
   {
      node->ImageIndex = 0; node->SelectedIndex = 0;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }
   else
   {
      node->ImageIndex = 1; node->SelectedIndex = 1;
      SaveBtn->Enabled = RefreshBtn->Enabled = true;
   }

   RECT r = { 0,0,50,2000 };
   InvalidateRect(TreeView->Handle,&r,false);
   modified = true;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::AddKeysImport(TMixKeyList1 *NewKeys)
{
   while (!initdone) AppProcessMessages(); // may not be init yet
   newkeys->Text = NewKeys->Text;

   keys->AddKeys(NewKeys);
   SetRedraw(this,0); TreeView->Items->Clear(); SetRedraw(this,1);
   AppProcessMessages(); SetRedraw(this,0); Sleep(300);
   GenTreeView();
   ClearAllBtn->Enabled = keys->Count>0 ? true:false;
   SetNothingSelected();
   SetRedraw(this,1);
   SaveBtn->Enabled = RefreshBtn->Enabled = true;
   if (hidedisabled) HideDisBtn->Click();
   SetNothingSelected();
   modified = true;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::SaveKeys()
{
   if (!keys->Count)
   {
      if (FileExists(MRINGTXT)) zapfile(MRINGTXT,1);
      return;
   }
   AnsiString cap = Caption;
   Caption = "Saving..."; AppProcessMessages(); Sleep(300);
   SaveBtn->Enabled = RefreshBtn->Enabled = false;
   keys->SaveToFileBak(MRINGTXT,STATSBAKCOPIES);
   modified = false;
   newkeys->Clear();
   Caption = cap;
   Sleep(200);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::WMSaveBtnClicked(TMessage& Msg)
{
   SaveBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::WMRefreshBtnClicked(TMessage& Msg)
{
   RefreshBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::WMImportBtnClicked(TMessage& Msg)
{
   ImportBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::WMDisableBtnClicked(TMessage& Msg)
{
   DisableBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::WMDeleteBtnClicked(TMessage& Msg)
{
   DeleteBtn->Click();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::WMGetKeyringMenuDat(TMessage& Msg)
{
  KeyringMenuDat *menudat = (KeyringMenuDat*)Msg.LParam;
  bool hassel = curkey>=0;
  menudat->Modified = modified;
  menudat->HasSel = hassel;
  menudat->RefreshEnabled = PopRefreshItem->Enabled; //
  menudat->CurEnabled = hassel ? keys->MixKey(curkey)->enabled : false;
  menudat->IsPair = false;
  Msg.Result = 1;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::ClearAllBtnClick(TObject *Sender)
{
   bool clrall;
   if (MixClearKeyring(AppMainForm,clrall))
   {
      Sleep(200); int i=0; while (i<keys->Count)
      {
         if (clrall || keys->MixKey(i)->enabled)
         {
            delete keys->Objects[i];
            keys->Delete(i);
            modified = true;
         }
         else i++;
      }
      if (hidedisabled) HideDisBtn->Click();
      RefreshBtn->Enabled = true;
      GenTreeView();
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::TreeViewMouseDown(TObject *Sender,
	TMouseButton Button, TShiftState Shift, int X, int Y)
{
   THitTests HitTest = TreeView->GetHitTestInfoAt(X, Y);
   if (HitTest.Contains(htOnIcon))
      DisableBtnClick(Sender);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::DisableBtnClick(TObject *Sender)
{
   if (curkey>=0) EnableKey(curkey,!NodeKey(curkey)->enabled);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::TreeViewChange(TObject *Sender, TTreeNode *Node)
{
   int node0 = Node->Level==0;
   RequestBtn->Enabled = node0;
   EnableDisableBtn(node0);
   DeleteBtn->Enabled = node0;
   curkey = Node->Index;
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::OkBtnClick(TObject *Sender)
{
   checksave = false;
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::FormCloseQuery(TObject *Sender, bool &CanClose)
{
   if (modified)
   {
      if (checksave)
      {
         switch (MsgBox("Your keyring is modified.\n\nSave your changes?",
            "Confirm",MB_YESNOCANCEL))
         {
            case IDCANCEL: CanClose = false;
            case IDNO: break;
            default:
               SaveKeys();
         }
      }
      else SaveKeys();
   }
   SetCount(true);
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::PopExpandItemClick(TObject *Sender)
{
   TreeView->FullExpand();
   if (keynodes->Count) TreeView->TopItem = (TTreeNode*)keynodes->Items[0];
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::PopCollapseItemClick(TObject *Sender)
{
   TreeView->FullCollapse();
   if (keynodes->Count) TreeView->TopItem = (TTreeNode*)keynodes->Items[0];
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::SaveBtnClick(TObject *Sender)
{
   SaveKeys();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::RefreshBtnClick(TObject *Sender)
{
   if (modified && MsgBox(
      s("Your keyring is modified. Refresh from disk will discard your changes?\n\n")+
      s("Refresh now?"),
      s("Confirm"),
      MB_OKCANCEL)==IDCANCEL) return;

   SaveBtn->Enabled = RefreshBtn->Enabled = false;
   AnsiString cap = Caption;
   Caption = "Loading...";
   newkeys->Clear();
   keynodes->Clear();
   LoadKeys();
   SetRedraw(this,0); TreeView->Items->Clear(); SetRedraw(this,1);
   AppProcessMessages(); SetRedraw(this,0); Sleep(300);
   GenTreeView();
   ClearAllBtn->Enabled = keys->Count>0 ? true:false;
   SetNothingSelected();
   SetRedraw(this,1);
   Caption = cap;
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::DeleteBtnClick(TObject *Sender)
{
   if (curkey<0) return;
   if (MixDeleteKey(AppMainForm))
   {
      delete keys->Objects[curkey];
      keys->Delete(curkey);
      bool locked = LockWindowUpdate(Handle); // works much better than setredraw here
      GenTreeView();
      AppProcessMessages(); Sleep(100);
      if (locked) LockWindowUpdate(0);
      SetNothingSelected();
      RefreshBtn->Enabled = true;
      modified = true;
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::RemailerDocItemClick(TObject *Sender)
{
   AnsiString doc; int d;
   TMenuItem *item = dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      doc = MixDir()+item->Caption;
      while ((d=doc.Pos("&"))>0) doc.Delete(d,1);
      if (FileExists(doc)) EditTextFile(doc);
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::HelpBtnClick(TObject *Sender)
{
   OpenHelp(
      "MixmasterKeys\nMixmasterKeysImp\nMixmasterKeysDup",
      "Mixmaster Key Manager",
      "Mixmaster Keyring Manager"
   );
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::RemailerConfigItemClick(TObject *Sender)
{
   TMenuItem *item=dynamic_cast<TMenuItem*>(Sender);
   if (item)
   {
      AnsiString remaddrs,subject,TempName;
      if (TreeView->Selected) remaddrs = TreeView->Selected->Text;
      remaddrs = GetParam(1,remaddrs," "); if (remaddrs.IsEmpty()) return;
      TStringList *temps = new TStringList();
      GetAppData(temps,UserTemplates);
      if (temps->IndexOf("config-request")>=0) TempName = "config-request";
      if (TempName.IsEmpty()) TempName =
          GetTemplateName("Select Template For Remailer Config-Request",modeMessage);
      if(!TempName.IsEmpty())
      {
         AnsiString cap = Caption; Caption = "Queueing message(s)...";
         TStringList *Template = new TStringList();
         GetAppData(Template,UserTemplates+PS+TempName);
         switch (item->Tag)
         {
            case 2:
               MakeMessage(Template,remaddrs,"remailer-config");
               break;
            case 3:
               MakeMessage(Template,remaddrs,"remailer-key"   );
               break;
            case 4:
               MakeMessage(Template,remaddrs,"remailer-help"  );
               break;
            case 5:
               MakeMessage(Template,remaddrs,"remailer-stats" );
               break;
            default:
               MakeMessage(Template,remaddrs,"remailer-config");
               MakeMessage(Template,remaddrs,"remailer-key"   );
               MakeMessage(Template,remaddrs,"remailer-help"  );
               MakeMessage(Template,remaddrs,"remailer-stats" );
               break;
         }
         AppMainForm->Perform(WM_QUEUECHANGE,0,NULL);
         AppMainForm->Perform(WM_SHOWSTATUS,0,
            (LPARAM)"Config-request(s) created and queued");
         delete Template;
         Sleep(200);
         Caption = cap;
      }
   }
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::FormActivate(TObject *Sender)
{
   SetCount();
}
//---------------------------------------------------------------------------
void __fastcall TMixKeyWin1::ImportBtnClick(TObject *Sender)
{
   AnsiString ImportDir,orgDir;
   TMixKeyList1 *impkeys = new TMixKeyList1();
   TMixKeyList1 *dupkeys = new TMixKeyList1();
   ImportDir = orgDir = GetAppIni(MixImportDir,MixDir());
   if (ImportMixmasterKeys(this,keys,impkeys,dupkeys,ImportDir))
   {
      if (impkeys->Count)
      {
         Sleep(100);
         BringToFront();
         AppProcessMessages();
         AddKeysImport(impkeys);
      }
      if (dupkeys->Count && this==MixKeyWin1)
      {
         //if (!MixProbWin) MixProbWin = new TMixProbWin(AppMainForm,false);
         //MixProbWin->BringToFront(); AppProcessMessages()
         //MixProbWin->AddKeysImport(dupkeys,false);
      }
   }
   if (ImportDir!=orgDir)
      PutAppIni(MixImportDir,ImportDir);
   delete dupkeys;
   delete impkeys;
}
//---------------------------------------------------------------------------
