//---------------------------------------------------------------------------
#ifndef PgpPassExH
#define PgpPassExH
//---------------------------------------------------------------------------
#include <vcl\ComCtrls.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ExtCtrls.hpp>
//---------------------------------------------------------------------------
// Keys is a list of key ids, current key tells dialog which to make current. After
// call current key indicated the key the phrase belongs to.
bool __fastcall PGPGETSignKeyIDAndPassphrase(TForm *Owner, TStrings *Keys,
   int &CurrentKey, AnsiString &Phrase);
bool __fastcall PGPGETConventionalPassphrase(TForm *Owner, AnsiString &Phrase);
bool __fastcall PGPGETDecryptionPassphrase(TForm *Owner, AnsiString &Phrase);
bool __fastcall PGPGETSecretKeyPassphrase(TForm *Owner, AnsiString &UserId,
   AnsiString &Phrase);
// on entry CancelMode tells dialog to show 'clear secure mode' button. on exit it
// tells if the user wants to cancel secure mode.
bool __fastcall PGPGETSecureModePassphrase(TForm *Owner, bool &CancelMode,
   AnsiString &Phrase);

const AnsiString SaveMsgClear = "SaveMsgClear";
enum PassMode { mConventionalPhrase, mSignKeyPhrase, mSecretKeyPhrase,
     mDecryptionPhrase, mSecureModePhrase };

class TPgpPassForm : public TForm
{
__published:	// IDE-managed Components
  TLabel *Label1;
  TComboBox *Keyid;
  TCheckBox *HideTypeBox;
  TLabel *Label2;
  TButton *OkBtn;
  TButton *CancelBtn;
  TMemo *Cnfirm;
  TMemo *Phrase;
  TLabel *Label3;
  TGroupBox *QualityBox;
  TProgressBar *ProgressBar1;
  TButton *ClearModeBtn;
  TCheckBox *SaveClearBox;
  TListBox *SecretKeyList;
  TLabel *Label4;
  void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
  void __fastcall HideTypeBoxClick(TObject *Sender);
  void __fastcall FormDestroy(TObject *Sender);
  void __fastcall PhraseChange(TObject *Sender);
  void __fastcall FormShow(TObject *Sender);
  void __fastcall ClearModeBtnClick(TObject *Sender);
  void __fastcall SaveClearBoxClick(TObject *Sender);
  void __fastcall SecretKeyListDrawItem(TWinControl *Control, int Index,
     TRect &Rect, TOwnerDrawState State);
private:	// User declarations
public:		// User declarations
  bool *HideType;
  TBrush *bkbrush;
  PassMode FormMode;
  virtual __fastcall TPgpPassForm(TComponent* Owner);
  virtual __fastcall TPgpPassForm(PassMode Mode, TComponent* Owner);
  virtual __fastcall~TPgpPassForm();
  void __fastcall ClearText();
};

//---------------------------------------------------------------------------
extern TPgpPassForm *PgpPassForm;
//---------------------------------------------------------------------------
#endif
